"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _assign = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/assign"));

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _loadableContext = _interopRequireDefault(require("./loadableContext"));

var _store = require("./store");

const connectedComponent = ({
  view,
  reducer,
  saga,
  viewProps
}) => {
  const View = view;
  return _react.default.createElement(_loadableContext.default.Consumer, null, ({
    errorBoundary
  }) => {
    const ErrorBoundary = errorBoundary;
    return _react.default.createElement(ErrorBoundary, null, _react.default.createElement(_reactRedux.ReactReduxContext.Consumer, null, ({
      store
    }) => {
      (0, _store.injectAsyncStore)(store, reducer, saga);
      return _react.default.createElement(View, (0, _assign.default)({}, viewProps));
    }));
  });
};

const unConnectedComponent = _react.default.createElement(_loadableContext.default.Consumer, null, ({
  loadingBoundary
}) => loadingBoundary);

var _default = ({
  reducer,
  saga,
  view,
  viewProps
}) => {
  const [component, setComponent] = _react.default.useState(unConnectedComponent);

  _react.default.useEffect(() => {
    const promises = [view];
    reducer && promises.push(reducer);
    saga && promises.push(saga);

    _promise.default.all(promises).then(values => {
      const [_view, _reducer, _saga] = values;
      setComponent(connectedComponent({
        view: _view.default,
        reducer: _reducer && _reducer.default,
        saga: _saga && _saga.default,
        viewProps
      }));
    });
  }, [true]);

  return component;
};

exports.default = _default;