"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _errorBoundary = _interopRequireDefault(require("./error/errorBoundary"));

var _loadableContext = _interopRequireDefault(require("./loadableContext"));

var _store = _interopRequireDefault(require("./store"));

const defaultLoading = _react.default.createElement("div", null, "loading...");

var _default = ({
  children,
  initReducer,
  reduxMiddlewares,
  loadingBoundary = defaultLoading,
  errorBoundary = _errorBoundary.default
}) => {
  const store = (0, _store.default)(initReducer, reduxMiddlewares);
  return _react.default.createElement(_reactRedux.Provider, {
    store: store
  }, _react.default.createElement(_loadableContext.default.Provider, {
    value: {
      loadingBoundary,
      errorBoundary
    }
  }, children));
};

exports.default = _default;